/* DUMPHEX.C - area dump function */

#include <stdio.h>
#include <ctype.h>
#include "environ.h" 

#define LINE_LIM 16

void dumphex(FILE *f, char *buff, int lth)
{
    int             line;
    int             linebase;
    int             pos;
    int             lines;
    unsigned char   c;

    lines = lth/LINE_LIM;
    if (lth > lines * LINE_LIM)
        lines++;

    for (line = 0; line < lines; line++)
    {
        linebase = line * LINE_LIM;
        fprintf(f,"%3d: ", linebase);
        for (pos = 0; pos < LINE_LIM; pos++)
        {
            if (linebase+pos >= lth)
                fprintf(f, " ");
            else
            {
                c = buff[linebase+pos];
                if (isascii(c) && isprint(c) && !iscntrl(c))
                    fprintf(f, "%c", c);
                else
                    fprintf(f, ".");
            }
        }

        fprintf(f, " : ");

        for (pos = 0; pos < LINE_LIM; pos++)
        {
            if (linebase+pos >= lth)
                fprintf(f, "   ");
            else
            {
                c = buff[linebase+pos];
                fprintf(f, "%02x ", c);
            }
        }

        fprintf(f, ":\n");
    }
}
