/* FILESIZE.C - Return the size of the currently open file */

#include <stdio.h>
#include "environ.h"

#ifdef OS9

#include <modes.h>

long filesize(name)
char*    name;
{
    int    f,size;
    
    f=open(name,S_IREAD & S_IOREAD);
    if (f == -1)
        return (long)f;    /* report failures with a negative reply */
        
    size = _gs_size(f);
    close(f);
    
    return (long)size;
}

#endif

#ifdef MSDOS
#include <stdio.h>
#include <sys/stat.h>

long filesize(name)
char*    name;
{
    struct stat statbuf;
    long        size;
    FILE        *f;

    f=fopen(name,"r");
    if (f == NULL)
        return (long)-1;    /* report failures with a negative reply */

    if (fstat(fileno(f), &statbuf))
        return (long)-1;
    fclose(f);
    size = statbuf.st_size;
    return (size);
}

#endif
#ifdef LINUX
#include <stdio.h>
#include <sys/stat.h>

long filesize(char *name)
{
    struct stat statbuf;
    long        size;
    FILE        *f;

    if (stat(name, &statbuf))
        return (long)-1;
    size = statbuf.st_size;
    return (size);
}

#endif

