/* TESTACC.C - Test harness for the diracc module */

#include <stdio.h>
#include <dirent.h>
#include "environ.h"

#ifdef MSDOS
#include <stdlib.h>
#endif

main(int argc, char **argv)
{
    DIRPATH    *dp;
    char       name[NAMELTH];
    char       dirname[NAMELTH];
    int        enttype;

    setprog(argv[0]);
    
    printf("\nDirectory: ");
    scanf("%s",dirname);
    printf("\n");

    dp = diropen(dirname);
    if (dp == NULL) 
    {
        printf("Can't open directory %s\n",dirname);
        exit(1);
    }

    while ((enttype = dirread(dp,name)) != DIR_EOF)
    {
        printf("Found [%s] - ",name);
        switch (enttype)
        {
            case DIR_NULL:    printf("null entry\n");
                            break;
            case DIR_SUBDIR: printf("directory\n");
                            break;
            case DIR_FILE:    printf("file\n");
                            break;
            default:        printf("bad reply(%d)\n",enttype);
        }
    }

    if(dirclose(dp) == EOF)
        printf("Can't close directory\n");

    printf("Test finished\n");

    return(0);
}