/* TESTLOGMSG.C - Test harness for logsetup(), logmsg() and logdump() */

#include <stdio.h>

#ifdef OSK
#include <strings.h>
#else
#include <string.h>
#include <stdlib.h>
#endif

#include "environ.h"

main(int argc, char **argv)
{
    char    line[80];
    long    i, j;
    long    waitfact;
    int     mode;

    setprog(argv[0]);

    if (argc<2)
        waitfact = 0;
    else
        waitfact = atol(argv[1]);
    printf("Wait factor = %ld\n", waitfact);

    if (argc<3)
        mode = INDIRECT_LOG;
    else
        mode = DIRECT_LOG;
    printf("Mode = %d\n", mode);

    logsetup(mode,STDOUT_LOG);
    
    while (fgets(line, 80, stdin))
    {
    	line[79] = 0;
        if (line[strlen(line)-1] == '\n')
            line[strlen(line)-1] = 0;
        if (strcmp(line,"end")==0) break;
        if (strcmp(line,"quit")==0) break;
        if (strcmp(line,"dump")==0) {
            printf("Dump requested\n");
            logdump();
    }
        else
            logmsg("Input was: %s\n", line);
        /*
            Waste some time
        */
        if (waitfact)
            for (i=0; i<waitfact; i++)
                j = strlen(line);
    }
    printf("Final dump\n");
    logdump();
    return 0;
}

