/* SETPAUSE.C - machine-dependent code to handle paging terminal output */

#include <errno.h>
#include "environ.h"

#ifdef OS9

#define _SCF_CLASS    0
#include <sgstat.h>

int _stored_state;

int setpause(action,pathno)
int action;
int pathno;
{
    struct sgbuf buffer;

    if (_gs_opt(pathno, &buffer) == -1)
        return(-1);     /* return with error if _gs_opt fails    */

    if (buffer.sg_class != _SCF_CLASS)
        return(E_BTYP); /* exit if not SCF device */
        
    switch(action)
    {
        case P_RECORD:    _stored_state = buffer.sg_pause;
                        break;

        case P_PAUSE:    buffer.sg_pause = 1;
                        break;

        case P_NOPAUSE:    buffer.sg_pause = 0;
                        break;

        case P_RESTORE:    buffer.sg_pause = _stored_state;
                        break;

        default:        return(E_ILLARG);
    }
    
    if (_ss_opt(pathno, &buffer) == -1)
        return(-1);                /* return with error if _gs_opt fails    */
    else
        return(0);                /* success                                */
}
#endif

#ifdef MSDOS

int setpause(int action, int pathno)
{
    return(0);
}

#endif

#ifdef LINUX

int setpause(int action, int pathno)
{
    return(0);
}

#endif

