/* SWAPDIR.C - Switch point of reference to the nominated
               directory and drive.

               The OS9/68K and Linux versions of this function are
               identical to chdir(). The MS-DOS version has some
               extra work to do to switch drives as well and to clean
               up in a tidy fashion if the combination of switching
               drive and directory does not work.
*/

#include <stdio.h>
#include "environ.h"

#ifdef MSDOS
#include <dir.h>
#include <ctype.h>
#endif

#ifdef LINUX
#include <unistd.h>
#endif

#ifdef OS9
int swapdir(path)
char *path;
{
    int r;

    r = chdir(path);
    return r;
}
#endif

#ifdef MSDOS
int swapdir(char *path)
{
    int     flags,
            olddrive,
            newdrive,
            r;
    char    drive[MAXDRIVE],
            dir[MAXDIR],
            file[MAXFILE],
            ext[MAXEXT];
            
    int fnsplit(const char *path, char *drive, char *dir, 
                char *name, char *ext);

    olddrive = getdisk();                        /* current drive */
    flags = fnsplit(path,drive,dir,file,ext);    /* parse pathname */
    if (flags & DRIVE)
        newdrive = toupper(drive[0]) - (int)'A'; /* drive no */
    else
        newdrive = olddrive;                     /* default = current */
    r = chdir(path);                             /* swap directories */
    if (r == 0)
        setdisk(newdrive);                       /* if OK, swap drives */
    return r;
}
#endif

#ifdef LINUX
int swapdir(char *path)
{
    int r;

    r = chdir(path);
    return r;
}
#endif

