/* TABDEFAULT.C - Get standard tab spacing

    Standard tab spacing is defined by: 

    1    the value in the stdout path descriptor if it points to
         an SCF device (OS/9 only).
    2    the environmental variable TABSPACE, if it is defined.
    3    TABSPACE in environ.h 

    These are inspected in sequence till a value is found.
*/

#include <stdio.h>
#include "environ.h"

#ifdef LINUX
#include <stdlib.h>
#endif

#ifdef MSDOS
#include <stdlib.h>
#endif

#ifdef OS9
char *getenv();
#include <sgstat.h>
int _gettab()
{
    struct sgbuf buffer;
    int r;
    
    r = _gs_opt(1,&buffer);
    if (r == -1)                                 /* bad path */
        return 0;
    if (buffer._sgm._sgs._sgs_class == 0)        /* SCF device */
        return (int)buffer._sgm._sgs._sgs_tabsiz;
    return 0;
}
#endif

int tabdefault()
{
    int     tabgap;
    char    *s;

#ifdef OS9
    tabgap = _gettab();
#endif

#ifdef MSDOS
    tabgap = 0;
#endif

#ifdef LINUX
    tabgap = 0;
#endif

    if (tabgap == 0)
    {
        s = getenv("TABSPACE");
        if (s)
	        tabgap = atoi(s);
    }
    if (tabgap == 0)
        tabgap = TABSPACE;

    return(tabgap);
}

